package comunicacao;

import comunicacao.data.segment.Segment;

public class CongestionControl {
	private Socket socket;
	
	private long cWind;
	private long ssthresh;
	@SuppressWarnings("unused")
	private long initialWindow;
	
	
	public CongestionControl(Socket socket){
		this.socket = socket;
		
		this.ssthresh = Segment.MAXIMUM_SEGMENT_SIZE << 3;
		this.initialWindow = Segment.MAXIMUM_SEGMENT_SIZE<<1;
		//this.initialWindow = Math.min(4*Segment.MAXIMUM_SEGMENT_SIZE, Math.max(2*Segment.MAXIMUM_SEGMENT_SIZE, 4380));
	}
	
	public synchronized void ackReceived(){
		if (this.cWind < this.ssthresh){
			this.slowStart();
		} else {
			this.congestionAvoidance();
		}
	}
	
	public synchronized long getCWind(){
		return this.cWind;
	}	
	
	private void slowStart(){
		this.cWind += Segment.MAXIMUM_SEGMENT_SIZE;
	}
	
	private void congestionAvoidance(){
		long aux = Segment.MAXIMUM_SEGMENT_SIZE*Segment.MAXIMUM_SEGMENT_SIZE/cWind;
		if (aux == 0){
			aux = 1;
		}		
		this.cWind += aux;
	}
	
	public void retransmissionTimeout(){
		this.ssthresh = Math.max (this.socket.getSender().getFlightSize() / 2, 2*Segment.MAXIMUM_SEGMENT_SIZE);
		this.cWind = Segment.MAXIMUM_SEGMENT_SIZE;
	}
	
	public void fastRecovery(){
		
	}
	
	public void fastRetransmit(){
		
	}
	
	
}
