package comunicacao;

import java.io.File;
import java.io.IOException;
import java.io.Serializable;
import java.net.InetAddress;

import comunicacao.exception.NotConnectedException;

public interface ISocket {

	void sendObject(Serializable ojb) throws IOException, NotConnectedException;
	
	void sendFile(File file) throws IOException, NotConnectedException;
	
	void sendFile(File file, Object fileState) throws IOException;
	
	Serializable readObject() throws IOException, ClassNotFoundException, NotConnectedException;
	
	File readFile() throws IOException, ClassNotFoundException, NotConnectedException;
	
	boolean connect() throws IOException;
	
	void close() throws IOException;
	
	InetAddress getRemoteAddress();
	
	int getRemotePort();
	
	double getUploadRate();
	
	double getDownloadRate();
	
	double getPercentage();
	
	
}
