package comunicacao.data;

import java.net.DatagramPacket;
import java.net.InetAddress;

import comunicacao.Socket;
import comunicacao.data.segment.Header;
import comunicacao.data.segment.HeaderFlags;
import comunicacao.data.segment.Segment;
import comunicacao.data.segment.SequenceNumber;

public class SegmentsConstructor {
	private Socket socket;
	
	private byte[] originalData;
	private InetAddress remoteIp;
	private int remotePort;

	private byte[] atributeArray;

	private int originalDataSize;
	private int totalOfSegments; // Number of segments
	
	private int copiedData; // Data that is been copied at the moment
	private int totalCopiedData; // Data that has been already copied

	public SegmentsConstructor(byte[] originalData, int originalDataSize, InetAddress remoteIP, int remotePort, Socket socket) {
		//TODO calculate atribute array size, not to always use 10MB
		this.socket = socket;
		
		this.originalData = originalData;
		this.remoteIp = remoteIP;
		this.remotePort = remotePort;
		
		this.atributeArray = new byte[10485760];
		
		this.originalDataSize = originalDataSize;
		this.totalOfSegments = 0;
		
		this.copiedData = 0;
		this.totalCopiedData = 0;

		Header header;
		int arrayIndex = Header.HEADER_SIZE;

		synchronized (this.socket.getSender().getSendingQueueAddMonitor()) {
			int index = 0;
			SequenceNumber seqNumAux;
			
			for (int i = 0; i < originalDataSize; i++) {

				/*-----------------------COPYING DATA------------------------*/

				this.atributeArray[arrayIndex + i] = this.originalData[i];
				this.copiedData++;
				this.totalCopiedData++;

				if ((this.copiedData == Segment.MAXIMUM_DATA_SIZE) || (this.totalCopiedData == this.originalDataSize)) {

					seqNumAux = new SequenceNumber(this.socket.getSendNextSeqNum().getInteger());
					this.socket.getSendNextSeqNum().add(this.copiedData);

					/*--------------------ATTACHING HEADER---------------------*/

					header = new Header(seqNumAux, this.socket.getReceiveNextSeqNum(),
							new HeaderFlags(false, false, false, false, false, true, 0));
					
					Segment segment = new Segment(header, new DatagramPacket(this.atributeArray, index,
							this.copiedData + Header.HEADER_SIZE, this.remoteIp, this.remotePort));
					
					this.socket.getSender().submit(segment);
					
					index += this.copiedData + Header.HEADER_SIZE;
					
					arrayIndex += Header.HEADER_SIZE;
					this.copiedData = 0;

				}

			}

		}

	}

	public int getNumberOfSegments() {
		return totalOfSegments;
	}

}
