package comunicacao.data.segment;

import java.net.DatagramPacket;

import comunicacao.exception.HeaderDontFitException;

public class Header {
	public static final int HEADER_SIZE = 9;
	private SequenceNumber segmentSequenceNumber;
	private SequenceNumber acknowledgmentNumber;
	private HeaderFlags flags;
	

	public Header (DatagramPacket packet){
		this.flags = new HeaderFlags(packet.getData()[0]);
		this.segmentSequenceNumber = new SequenceNumber(packet.getData()[1], packet.getData()[2],packet.getData()[3],packet.getData()[4]);
		this.acknowledgmentNumber = new SequenceNumber(packet.getData()[5], packet.getData()[6],packet.getData()[7],packet.getData()[8]);
	}

	
	
	public Header(SequenceNumber segmentSequenceNumber,
			SequenceNumber acknowledgmentNumber, HeaderFlags flags) {
		super();
		this.segmentSequenceNumber = segmentSequenceNumber;
		this.acknowledgmentNumber = acknowledgmentNumber;
		this.flags = flags;
	}



	


	public boolean isRST() {
		return this.flags.isRst();
	}

	public boolean isACK() {
		return this.flags.isAck();
	}

	public boolean isSYN() {
		return this.flags.isSyn();
	}



	public SequenceNumber getSegmentSequenceNumber() {
		return segmentSequenceNumber;
	}



	public void setSegmentSequenceNumber(SequenceNumber segmentSequenceNumber) {
		this.segmentSequenceNumber = segmentSequenceNumber;
	}



	public SequenceNumber getAcknowledgmentNumber() {
		return acknowledgmentNumber;
	}



	public void setAcknowledgmentNumber(SequenceNumber acknowledgmentNumber) {
		this.acknowledgmentNumber = acknowledgmentNumber;
	}



	public boolean isFyn() {
		return this.flags.isFyn();
	}



	public HeaderFlags getFlags() {
		return flags;
	}



	public void setFlags(HeaderFlags flags) {
		this.flags = flags;
	}

	
	
	
}
