package comunicacao.data.segment;

public class SequenceNumber implements Cloneable{
	private int integer;

	public SequenceNumber(int signedInteger) {
		super();
		this.integer = signedInteger;
	}
	
	public SequenceNumber(byte leftByte, byte middleLeftByte,
			byte middleRightByte, byte rightByte) {
		

		int number = leftByte;
		number = (number << 8) + (middleLeftByte & 0xff);
		number = (number << 8) + (middleRightByte & 0xff);
		number = (number << 8) + (rightByte & 0xff);
		this.integer = number;

	}
	
	
	public synchronized int getInteger() {
		return integer;
	}

	public synchronized void setInteger(int integer) {
		this.integer = integer;
	}
	
	public synchronized void advanceToReach(SequenceNumber number){
//		if (number.getInteger() > this.integer){
			this.setInteger(number.getInteger());
//		}
	}
	public synchronized void advanceToReach(int i) {
//		if (i > this.integer){
			this.setInteger(i);
//		}		
	}
	
	public synchronized SequenceNumber clone(){
		return new SequenceNumber(integer);
	}

	public synchronized void advance(int amount) {
		this.integer += amount;
	}

	public synchronized void add(int length) {
		this.advance(length);		
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + integer;
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		SequenceNumber other = (SequenceNumber) obj;
		if (integer != other.integer)
			return false;
		return true;
	}

	
	
	
	
}
