package comunicacao.sender;

public class TimeoutAlgorith {
	private long timeout;
	private long estimatedRTT;
	private long rttVar;
	
	private int counter;
	private boolean initialized;
	
	public TimeoutAlgorith(){
		this.timeout = 3000L;
		this.estimatedRTT = 0;
		this.rttVar = 0;
		
		this.counter = 0;
		this.initialized = false;
	}
	
	public synchronized long getTimeout(){
		return Math.min(this.timeout, 60000);
	}
	
	//TODO Use this thing
	public synchronized void rttMeasured(long sampleRTT){
			if (initialized){
				
				long aux;
				if (sampleRTT > this.estimatedRTT) {
					aux = sampleRTT - this.estimatedRTT;
				} else {
					aux = this.estimatedRTT - sampleRTT;
				}
				this.rttVar = ((this.rttVar - (this.rttVar >> 2)) + (aux >> 2));
			
				this.estimatedRTT = ((this.estimatedRTT - (this.estimatedRTT >> 3)) + (sampleRTT >> 3));
				this.timeout = Math.max(this.estimatedRTT + (this.rttVar << 2), 1000);
			} else {
				this.estimatedRTT = sampleRTT;
				this.rttVar = sampleRTT/2;
				this.timeout = Math.max(this.estimatedRTT + (this.rttVar << 2), 1000);
				this.initialized = true;	
			}
	}
	
	public synchronized void backOff(){
		this.timeout = this.timeout << 2;
		this.counter++;
		
		if (this.counter == 5){
			this.counter = 0;
			this.initialized = false;
		}
	}
}
