package comunicacao.util;

import java.util.Comparator;

import comunicacao.Socket;
import comunicacao.data.segment.Segment;
import comunicacao.data.segment.SequenceNumber;

public class ReceiveNextComparator implements Comparator<Segment> {

	private Socket socket;

	public ReceiveNextComparator(Socket socket) {
		this.socket = socket;
	}

	@Override
	public int compare(Segment segNum1, Segment segNum2) {
		SequenceNumber seqNum1 = segNum1.getSequenceNumber();
		SequenceNumber seqNum2 = segNum2.getSequenceNumber();
		synchronized (this.socket.getSeqNumMonitor()) {

			if (this.socket.getReceiveNextSeqNum().getInteger() < this.socket
					.getReceiveNextSeqNum().getInteger()
					+ this.socket.getReceiveWindow()) {

				return seqNum1.getInteger() - seqNum2.getInteger();

			} else {
				if (seqNum1.getInteger() >= this.socket
						.getReceiveNextSeqNum().getInteger()) {
					if (seqNum2.getInteger() >= this.socket
							.getReceiveNextSeqNum().getInteger()) {
						// The Sequence Numbers are in the same side
						return seqNum1.getInteger()
								- seqNum2.getInteger();
					} else {
						return -1;
					}
				} else {
					if (seqNum2.getInteger() >= this.socket
							.getReceiveNextSeqNum().getInteger()) {
						// The Sequence Numbers are in the same side
						return 1;
					} else {
						return seqNum1.getInteger()
						- seqNum2.getInteger();
					}
				}

			}

		}

	}

}
