package core;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Random;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import userManagement.User;

import comunicacao.IServerSocket;
import comunicacao.ISocket;
import comunicacao.ServerSocket;
import comunicacao.exception.NotConnectedException;

public class ActionServer extends ProgramServer implements Runnable {
	private ISocket socket;
	private ArrayList<ReciveCommand> threads;
	private User user;
	private boolean active;
	private ExecutorService serverThread;

	public ActionServer(ISocket socket) throws IOException {
		this.active = true;
		this.socket = socket;
		this.threads = new ArrayList<ReciveCommand>();
	}

	public void run() {
		try {
			serverThread = Executors.newCachedThreadPool();
			while (this.active) {
				String command = (String) socket.readObject();
				if (command.equals("registerUser")) {
					socket.sendObject(registerUser(
							(String) socket.readObject(),
							(String) socket.readObject(),
							(String) socket.readObject()));
					break;
				} else if (command.equals("verifyUser")) {
					this.user = verifyUser((String) socket.readObject(),
							(String) socket.readObject());
					if (user != null) {
						socket.sendObject(true);
						socket.sendObject(user);
					} else {
						socket.sendObject(false);
						break;
					}
				} else if (command.equals("desconect")) {
					break;
				} else if (command.equals("synchronizing")) {
					System.out.println("synchronizing1");
					File status = socket.readFile();
					System.out.println("synchronizing2");
					(new VerifierServer(user, status, this)).verifier();
					status.delete();
				} else {
					boolean ok = false;
					int port = 0;
					Random random = new Random();
					IServerSocket serverSocket = null;
					while (!ok) {
						try {
							port = random.nextInt(65535) + 1;
							serverSocket = new ServerSocket(port);
							ok = true;
						} catch (Exception e) {
							ok = false;
						}
					}
					socket.sendObject(port);
					ReciveCommand reciveCommand = new ReciveCommand(
							serverSocket, command);
					threads.add(reciveCommand);
					serverThread.submit(reciveCommand);
				}
			}
			socket.close();
			this.active = false;
		} catch (Exception e) {

		}
	}
	public void sendCommand(String fileName, String command){
		sendCommand(null, command,fileName);
	}
	public void sendCommand(File file, String command, String fileName) {
		System.out.println("mandando o aquivo "+fileName+" com o comando "+command);
		try {
			socket.sendObject(command);
			if(!command.equals("ok")){
				socket.sendObject(fileName);
				boolean ok = false;
				int port = 0;
				Random random = new Random();
				IServerSocket serverSocket = null;
				while (!ok) {
					try {
						port = random.nextInt(65535) + 1;
						serverSocket = new ServerSocket(port);
						ok = true;
					} catch (Exception e) {
						ok = false;
					}
				}
				socket.sendObject(port);
				ReciveCommand reciveCommand = new ReciveCommand(
						serverSocket, command, file);
				threads.add(reciveCommand);
				serverThread.submit(reciveCommand);
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NotConnectedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	@Override
	public void desconect() {
		this.active = false;

	}

	public ArrayList<InformationCliente> getInformationClientes() {

		ArrayList<InformationCliente> informationClientes = new ArrayList<InformationCliente>();
		for (int i = 0; i < threads.size(); i++) {
			if (threads.get(i).isActive()) {
				informationClientes.add(threads.get(i).getInformationCliente());
			} else {
				threads.remove(i--);
			}
		}
		return informationClientes;
	}

	public ISocket getSocket() {
		return socket;
	}

	public boolean isActive() {
		return active;
	}

	public User getUser() {
		return user;
	}


	@Override
	public void setIp(String ip) {
		// TODO Auto-generated method stub
		
	}

}
