package core;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;

import comunicacao.exception.NotConnectedException;

import userManagement.User;


public abstract class ProgramServer {

	private static String filesDir = "Files\\";
	public static String usersDir = "Users\\";
	
	public ProgramServer() {
		(new File("Files")).mkdir();
		(new File("Users")).mkdir();
	}
	

	public boolean registerUser(String name, String email, String password) throws IOException, NotConnectedException{
		File files = new File("Users");
		for(String user : files.list()){
			if(user.equals(email)){
				return false;
			}
		}
		ObjectOutputStream newUser = new ObjectOutputStream(
				new FileOutputStream(new File(usersDir+email)));
		newUser.writeObject(new User(name,email, password));
		newUser.close();
		(new File(getFilesDir()+email)).mkdir();
		return true;
	}

	public User verifyUser(String email, String password) throws ClassNotFoundException, IOException, NotConnectedException{
		ObjectInputStream userInput = new ObjectInputStream(
				new FileInputStream(new File(usersDir+email)));
		User user = (User) userInput.readObject();
		if(user.getPassword().equals(password)){
			return user;
		}
		else{
			//Exception erro: password invalido
			return null;
		}
	}
	/*public void userSharedAppend(User user, ArrayList<String> shares, File file) throws FileNotFoundException, IOException, ClassNotFoundException{
		String fileName = file.getPath().substring(file.getPath().indexOf("DropBox")+7);
		String fileNameTemp = user.getEmail()+fileName;
		(new File(filesDir+fileNameTemp)).mkdir();
		ObjectOutputStream listShared = new ObjectOutputStream(
				new FileOutputStream(filesDir+fileNameTemp+"\\yambox.yam",true));
		User userAppended = (User) (new ObjectInputStream(
				new FileInputStream(new File(usersDir+user.getEmail())))).readObject();
		//System.out.println(fileNameTemp);
		String mapping = fileNameTemp.substring(fileNameTemp.indexOf('\\')+1);
		int index = mapping.indexOf('\\');
		if(index != -1){
			mapping = mapping.substring(0,index);
		}
		//System.out.println(mapping);
		userAppended.appendFile(mapping,
				fileNameTemp.substring(0,fileNameTemp.indexOf('\\')));
		(new ObjectOutputStream(
				new FileOutputStream(usersDir+user.getEmail()))).writeObject(userAppended);
		//System.out.println(userAppended);
		for (int i = 0; i < shares.size(); i++) {
			userAppended = (User) (new ObjectInputStream(
					new FileInputStream(new File(usersDir+shares.get(i))))).readObject();
			//System.out.println("Apeend "+fileNameTemp+" para "+userAppended.getEmail());
			userAppended.appendFile(file.getName(),fileNameTemp.substring(0,fileNameTemp.lastIndexOf('\\')));
			listShared.writeObject(shares.get(i));
			(new ObjectOutputStream(
					new FileOutputStream(usersDir+shares.get(i)))).writeObject(userAppended);
		}
		listShared.close();
	}
	
	public void putFile(User user, String address, File file){
		ArrayList<String> broadCast = creatNewFile(address, file);
		for (int i = 0; i < broadCast.size(); i+= 2) {
			if(!broadCast.get(i).equals(user.getEmail()))
				System.out.println("Enviar o arquivo "+address+" para "+broadCast.get(i)+" no local "+broadCast.get(i+1));
		}
	}
	*/
	public void putFile(User user, String address, File file){
		creatNewFile(user.getEmail()+'\\'+address, file);
	}
	public void putDirectory(User user, String address){
		System.out.println("Criando diretorio..."+address);
		creatNewDiretory(user.getEmail()+'\\'+address);
	}
	private void creatNewFile(String address, File file){
		File oldFile = new File(filesDir+address);
		//File oldFile = new File("Files\rlfs@cin.ufpe.br\t.jpg");
		if(oldFile.exists()){
			oldFile.delete();
		}
		if(!file.renameTo(oldFile)){
			creatNewDirectoryStruct(filesDir, address);
			file.renameTo(oldFile);
		}
	}
	private void creatNewDiretory(String address){
		(new File(getFilesDir()+address)).mkdir();
	}
	
	public void delete(User user, String address){
		System.out.println("O programr server quer deletar "+address);
		File fileDelete = new File(getFilesDir()+user.getEmail()+'\\'+address);
		while(!(fileDelete.exists() && fileDelete.canWrite())){
			Thread.yield();
		}
		if(fileDelete.isDirectory()){
			deleteDirectory(fileDelete.listFiles());
		}
		fileDelete.delete();
	}
	private void deleteDirectory(File[] files){
		for(File file: files){
			while(!(file.exists() && file.canWrite())){
				Thread.yield();
			}
			if(file.isDirectory()){
				deleteDirectory(file.listFiles());
			}
			file.delete();
		}
	}
	
	private void creatNewDirectoryStruct(String oldString, String addres){
		//System.out.println(addres);
		int index = addres.indexOf('\\');
		if(index != -1){
			String nameTemp = oldString + addres.substring(0,index);
			//System.out.println(nameTemp);
			(new File(nameTemp)).mkdir();
			creatNewDirectoryStruct(nameTemp+'\\', addres.substring(addres.indexOf('\\')+1));
			/*File yambox = new File(nameTemp+"\\yambox.yam");
			System.out.println(nameTemp);
			if(yambox.exists()){
				try {
					ObjectInputStream sharesInput = new ObjectInputStream(
							new FileInputStream(yambox));
					while(true){
						broadCast.add((String) sharesInput.readObject());
						broadCast.add(nameTemp.substring(nameTemp.indexOf('\\')+1));
					}
				} catch (IOException e) {
					//System.out.println("Acho que  fim de arquivo");
					//e.printStackTrace();
				} catch (ClassNotFoundException e) {
					//e.printStackTrace();
				}
			}
			return broadCast;
			*/
		}/*
		else{
			ArrayList<String> broadCast = new ArrayList<String>();
			return broadCast;
		}
		*/
	}
	public ArrayList<String> synchronizing(User user, File file,String address){
		ArrayList<String> array = new ArrayList<String>();
		return array;
	}
	
	
	
	public static String[] getAllUsers(){
		File file = new File("Users");
		return file.list();
	}
	
	public abstract void desconect();
	
	public abstract void setIp(String ip);


	public static void setFilesDir(String filesDir) {
		ProgramServer.filesDir = filesDir;
	}

	public static String getFilesDir() {
		return filesDir;
	}
}
