package core;
import java.io.File;
import java.io.IOException;

import userManagement.User;

import comunicacao.IServerSocket;
import comunicacao.ISocket;
import comunicacao.exception.NotConnectedException;

public class ReciveCommand extends ProgramServer implements Runnable {
	private IServerSocket serverSocket;
	private String command;
	private boolean active;
	private File file;
	private GetInformationsClient getInformationsClient;

	public ReciveCommand(IServerSocket serverSocket, String command) {
		this.getInformationsClient = null;
		this.serverSocket = serverSocket;
		this.command = command;
		active = true;
	}
	public ReciveCommand(IServerSocket serverSocket, String command, File file) {
		this.getInformationsClient = null;
		this.serverSocket = serverSocket;
		this.command = command;
		this.file = file;
		active = true;
	}

	
	public void run() {
		try {
			ISocket socket = serverSocket.accept();
			User user = (User) socket.readObject();
			String address = (String) socket.readObject();
			if (command.equals("putFile")){
				this.getInformationsClient = new GetInformationsClient(socket, user, new File(address), 'D');
				File file = socket.readFile();
				System.out.println("Usuario: " + user + "Endereco: "
						+ address + "\nPath name: "
						+ file.getPath()+"\nEh um arquivo e  ele existe = "+file.exists());
				putFile(user, address, file);
			}else if (command.equals("send")){
				this.getInformationsClient = new GetInformationsClient(socket, user, new File(address), 'D');
				if(socket.readObject().equals("file")){
					File file = socket.readFile();
					System.out.println("Usuario: " + user + "Endereco: "
							+ address + "\nPath name: "
							+ file.getPath()+"\nEh um send.");
					putFile(user, address, file);
				}
			} else if( command.equals("receive")){
				getInformationsClient = new GetInformationsClient(socket,user,file,'U');
				while(!file.canRead()){
					Thread.yield();
				}
				socket.sendFile(file);
			} else {
				System.out.println("Esta entrando no deletar do receive do servidor "+command);
				delete(user, address);
			}
			socket.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NotConnectedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		this.getInformationsClient.desconecte();
		active = false;
	}

	public InformationCliente getInformationCliente(){
		if(getInformationsClient != null){
				return getInformationsClient.getInformationCliente();
		}
		else{
			return null;
		}
	}
	
	public boolean isActive() {
		return active;
	}

	@Override
	public void desconect() {
		// TODO Auto-generated method stub

	}
	@Override
	public void setIp(String ip) {
		// TODO Auto-generated method stub
		
	}
}
