package core;
import java.io.File;
import java.io.IOException;
import java.net.InetAddress;
import java.net.UnknownHostException;

import userManagement.User;

import comunicacao.ISocket;
import comunicacao.Socket;
import comunicacao.exception.NotConnectedException;

public class SendingCommand extends Thread {
	private String ip;
	private int port;
	private String command;
	private User user;
	private String address;
	private File file;
	private GetInformationsClient getInformationsClient;
	private boolean active;
	

	public SendingCommand(String ip, int port, String command, User user,
			String address, File file) {
		this.getInformationsClient = null;
		this.ip = ip;
		this.port = port;
		this.command = command;
		this.user = user;
		this.address = address;
		this.file = file;
		this.active = true;
	}
	public SendingCommand(String ip, int port, String command, User user,
			String address) {
		this.ip = ip;
		this.port = port;
		this.command = command;
		this.user = user;
		this.address = address;
	}


	public void run() {
		while(true){
			try {
				ISocket socket = new Socket(InetAddress.getByName(ip), port);
				socket.sendObject(user);
				socket.sendObject(address);
				if (command.equals("putFile")) {
					System.out.println("No cliente, o comando "+command+" para o arquivo "+file.getName());
					getInformationsClient = new GetInformationsClient(socket,user,file,'U');
					while(!file.canRead()){
						Thread.yield();
					}
					socket.sendFile(file);
				}
				if (command.equals("send")){
					System.out.println("No cliente, o comando "+command+" para o arquivo "+file.getName());
					if(file.isDirectory()){
						socket.sendObject("directory");
					}
					else{
						socket.sendObject("file");
						getInformationsClient = new GetInformationsClient(socket,user,file,'U');
						while(!file.canRead()){
							Thread.yield();
						}
						socket.sendFile(file);
					}
				}
				else if( command.equals("receive")){
					File newFile = new File(address);
					getInformationsClient = new GetInformationsClient(socket, user, newFile, 'D');
					File file = socket.readFile();
					file.renameTo(newFile);					
				}
				socket.close();
				Thread.sleep(10000);
				break;
			} catch (UnknownHostException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			} catch (InterruptedException e) {
				e.printStackTrace();
			} catch (ClassNotFoundException e) {
				e.printStackTrace();
			} catch (NotConnectedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		this.getInformationsClient.desconecte();
		this.active = false;
	}
	
	public InformationCliente getInformationCliente(){
		if(getInformationsClient != null){
				return getInformationsClient.getInformationCliente();
		}
		else{
			return null;
		}
	}
	public boolean isActive() {
		return active;
	}}
