package core;

import java.io.IOException;
import java.util.ArrayList;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import userManagement.User;
import comunicacao.IServerSocket;
import comunicacao.ServerSocket;

public class ServerComunication extends Thread {

	private ArrayList<ActionServer> threadUser;

	public ServerComunication() throws IOException, ClassNotFoundException {
		super();
		threadUser = new ArrayList<ActionServer>();
	}

	public void run() {
		try {
			listenConection();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private void listenConection() throws IOException, ClassNotFoundException {
		IServerSocket serverSocket = new ServerSocket(2000);
		ExecutorService server = Executors.newCachedThreadPool();
		while (true) {
			ActionServer actions = new ActionServer(serverSocket.accept());
			threadUser.add(actions);
			server.submit(actions);
		}
	}

	public ArrayList<InformationServerUser> getInformationServerUsers() {
		ArrayList<InformationServerUser> allUsers = getAllUsers();
		for (int i = 0; i < this.threadUser.size(); i++) {
			if (threadUser.get(i).isActive()) {
				if (threadUser.get(i).getUser() != null) {
					int j;
					for (j = 0; j < allUsers.size(); j++) {
						if(allUsers.get(j).getUser().equals(threadUser.get(i).getUser().getEmail())){
							break;
						}
					}
					allUsers.get(j).setIP(
							threadUser.get(i).getSocket().getRemoteAddress()
									.getHostAddress());
				}
			} else {
				threadUser.remove(i);
			}
		}
		return allUsers;
	}

	private ArrayList<InformationServerUser> getAllUsers() {
		String[] allUsers = ActionServer.getAllUsers();
		ArrayList<InformationServerUser> array = new ArrayList<InformationServerUser>();
		for (int i = 0; i < allUsers.length; i++) {
			array.add(new InformationServerUser(allUsers[i],
					"*", false, false));
		}
		return array;
	}

	public ArrayList<InformationCliente> getInformationClientes() {
		ArrayList<InformationCliente> informationClientes = new ArrayList<InformationCliente>();
		for (ActionServer action : threadUser) {
			if (action.isActive()) {
				if (action.getUser() != null) {
					informationClientes.addAll(action.getInformationClientes());
				}
			}
		}
		return informationClientes;
	}

}
