package core;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Scanner;

import userManagement.User;


public class Verifier extends Thread {

	private File status = new File("status.txt");
	private Scanner statusInput;
	private BufferedWriter temp;
	private String fileName = "";
	private long fileLastModified = 0;
	private ClienteOut clienteOut;
	private String addressYamBox;
	private boolean active;
	private ArrayList<String> synchronize;
	private boolean modify;
	private int lastModify;
	
	public Verifier(User user, String addressYamBox, ProgramServer programServer){
		this.clienteOut = new ClienteOut (user,programServer,addressYamBox);
		this.addressYamBox = addressYamBox;
		this.synchronize = new ArrayList<String>();
	} 
	
	public void run(){
		try {
			int i = 0;
			this.active = true;
			this.lastModify = 0;
			while(this.active){
				System.out.println(i++);
				Thread.sleep(500);
				this.modify = false;
				verifier();
				if(!this.modify){
					this.lastModify++;
				}
				else{
					this.lastModify = 0;
				}
				if(this.lastModify == 40){
					//synchronizing();
					this.lastModify = 0;
				}
			}
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		this.clienteOut.desconecte();
	}
	
	public void verifier() throws IOException{
		try {
			temp = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(new File("temp.txt"))));
			if(!status.exists()){
				status.createNewFile();
			}
			statusInput = new Scanner(status);
				File fileTemp = new File(addressYamBox);
				if(fileTemp.exists()){
					//File[] fileTempArray = {fileTemp};
					File[] fileTempArray = fileTemp.listFiles();
					list(fileTempArray);
				}
			while(statusInput.hasNext()){
				fileName = statusInput.nextLine();
				fileLastModified = statusInput.nextLong();
				statusInput.nextLine();
				if(thereIs(fileName)){
					//printTemp(fileName, 0);
				}
				else{
					printErro(fileName,"Deletar");
				}
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		statusInput.close();
		if(status.delete()){
			temp.close();
			(new File("temp.txt")).renameTo(status);
		}
	}
	
	private void synchronizing(){
		ArrayList<String> temp = clienteOut.synchronizing(status);
		for (int i = 0; i < temp.size(); i++) {
			Ordenate(status,temp.get(i));
		}
		synchronize.addAll(temp);
	}
	
	public void Ordenate(File file,String path){
		try {
			BufferedReader fr = new BufferedReader(new FileReader(file));
			ArrayList<String> lista = new ArrayList<String>();
			ArrayList<String> lista2=new ArrayList<String>();
			if(!AlreadyExists(path,file)){
					while(true){
						String line=fr.readLine();
						if(line==null){
						break;
						}
						lista.add(line);
						String line2=fr.readLine();
						lista2.add(line2);
					}
					fr.close();
					BufferedWriter fo=new BufferedWriter(new FileWriter(file));
					lista.add(path);
					Collections.sort(lista);
					boolean achou=false;
					int j=0;
					for(int i=0;i<lista.size()&&!achou;i++){
						if(lista.get(i).compareTo(path)==0){
							fo.write(lista.get(i)+"\r\n"+"0"+"\r\n");
							
						}
						else{
							fo.write(lista.get(i)+"\r\n"+lista2.get(j)+"\r\n");
							j++;
						}
					}
					fo.close();
				}			
		} catch (Exception e) {
		}
		
	}
	public static boolean AlreadyExists(String path,File file) {
		boolean real=false;
		try {
			BufferedReader fr=new BufferedReader(new FileReader(file));
			while(true){
			String line=fr.readLine();
			if(line==null){
				//fr.close();
				break;
			}
			if(line.compareTo(path)==0){
				real=true;
			}
			}
		} catch (FileNotFoundException e) {
			
		} catch (IOException e) {
			real=false;
		}
		return real;
		
	}
	
	private boolean thereIs(String file){
		for (String files :  synchronize) {
			if(files.equals(file)){
				return true;
			}
		}
		return false;
	}
	
	private void remove(String file){
		for (String files :  synchronize) {
			if(files.equals(file)){
				synchronize.remove(files);
				break;
			}
		}
	} 
	
	public boolean list(File[] files) throws IOException{
		Arrays.sort(files);
		boolean statusOk = true;
		boolean actualOk = false;
		for (int i = 0; i < files.length; i++) {
			while(!actualOk){
				if(statusOk){
					if(statusInput.hasNext()){
						fileName = statusInput.nextLine();
						fileLastModified = statusInput.nextLong();
						statusInput.nextLine();
					}
					else{
						listAndSend(files,i);	
						return true;
					}
				}
				if(files[i].getPath().equals(fileName)){
						if(files[i].lastModified() != fileLastModified && files[i].isFile()){
							if(thereIs(fileName)){
								remove(fileName);
							}
							else{
								printErro(files[i],"Enviar");
							}
						}
						printTemp(files[i]);
						statusOk = true;
						actualOk = true;
				}
				else if(files[i].getPath().compareTo(fileName) > 0){
					if(thereIs(fileName)){
						printTemp(fileName, 0);
					}
					else{
					    printErro(fileName,"Deletar");
					}
					statusOk = true;
					actualOk = false;
				}
				else{
					if(thereIs(files[i].getPath())){
						remove(fileName);
					}
					else{
						printErro(files[i],"Enviar");
					}
					printTemp(files[i]);
					statusOk = false;
					actualOk = true;
				}
				
			}
			actualOk = false;
			if(files[i].isDirectory()){
				list(files[i].listFiles());
			}
		}
		return true;
	}
	
	public void listAndSend(File[] files,int i) throws IOException{
		Arrays.sort(files);
		System.out.println("entrou no 'for' do listandsend");
		for (; i < files.length; i++) {
			printTemp(files[i]);
			if(thereIs(fileName)){
				remove(fileName);
			}
			else{
				printErro(files[i],"Enviar");
				if(files[i].isDirectory()){
					listAndSend(files[i].listFiles(),0);
				}
			}
		}
	}
	public void printTemp(File file) throws IOException{
		temp.write(file.getPath()+"\r\n"+file.lastModified()+"\r\n");
	}
	public void printTemp(String file,int lastModified) throws IOException{
		temp.write(file+"\r\n"+lastModified+"\r\n");
	}
	public void printErro(String file,String command) throws IOException{
		this.modify = true;
		clienteOut.sendComand(new File(file), command);
	}
	public void printErro(File file,String command) throws IOException{
		this.modify = true;
		clienteOut.sendComand(file, command);
	}
	
	public void desconecte(){
		System.out.println("desconectando");
		this.active = false;
		
	}
}
