package core;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Arrays;
import java.util.Scanner;

import userManagement.User;

public class VerifierServer {
	private File status;
	private Scanner statusInput;
	private String fileName = "";
	private long fileLastModified = 0;
	private ActionServer programServer;
	private String addressYamBox;
	private User user;
	private String fileHd;
	
	public VerifierServer(User user, File status, ActionServer programServer){
		this.user = user;
		this.programServer = programServer;
		this.addressYamBox = ProgramServer.getFilesDir()+user.getEmail();
		this.status = status;
		
	}
	public void verifier() throws IOException{
		try {
			statusInput = new Scanner(status);
			File fileTemp = new File(addressYamBox);
			if(fileTemp.exists()){
				//File[] fileTempArray = {fileTemp};
				File[] fileTempArray = fileTemp.listFiles();
				list(fileTempArray);
			}
			while(statusInput.hasNext()){
				fileName = statusInput.nextLine();
				fileLastModified = statusInput.nextLong();
				statusInput.nextLine();
				fileName = fileName.substring(fileName.indexOf("YamBox")+7);
				printErro(fileName,"send");
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		statusInput.close();
		System.out.println("mandando o OK");
		printErro("", "ok");
	}

	public boolean list(File[] files) throws IOException{
		Arrays.sort(files);
		boolean statusOk = true;
		boolean actualOk = false;
		for (int i = 0; i < files.length; i++) {
			while(!actualOk){
				if(statusOk){
					if(statusInput.hasNext()){
						fileName = statusInput.nextLine();
						fileLastModified = statusInput.nextLong();
						statusInput.nextLine();
					}
					else{
						listAndSend(files,i);	
						return true;
					}
				}
				fileName = fileName.substring(fileName.indexOf("YamBox")+7);
				fileHd = files[i].getPath().substring(ProgramServer.getFilesDir().length()+user.getEmail().length()+1);
				System.out.println("Verificando "+fileHd+ " com "+fileName);				
				if(fileHd.equals(fileName)){
						statusOk = true;
						actualOk = true;
				}
				else if(fileHd.compareTo(fileName) > 0){
					printErro(fileName,"send");//troquei esse comando com o de baixo
					statusOk = true;
					actualOk = false;
				}
				else{
					printErro(files[i],"receive",fileHd);//troquei esse comando com o de cima
					statusOk = false;
					actualOk = true;
				}
				
			}
			actualOk = false;
			if(files[i].isDirectory()){
				list(files[i].listFiles());
			}
		}
		return true;
	}
	
	public void listAndSend(File[] files,int i) throws IOException{
		Arrays.sort(files);
		for (; i < files.length; i++) {
			fileHd = files[i].getPath().substring(ProgramServer.getFilesDir().length()+user.getEmail().length()+1);
			printErro(files[i],"receive",fileHd);
			if(files[i].isDirectory()){
				listAndSend(files[i].listFiles(),0);
			}
		}
	}
	
	public void printErro(String file,String command) throws IOException{
		programServer.sendCommand(file, command);
	}
	public void printErro(File file,String command, String address) throws IOException{
		programServer.sendCommand(file, command, address);
	}
}
