package gui;
import java.awt.Color;

import javax.swing.JFrame;
import javax.swing.JPanel;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.CategoryPlot;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.renderer.xy.StandardXYItemRenderer;
import org.jfree.chart.renderer.xy.XYItemRenderer;
import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;

public class Grafico extends JPanel {
	
	private XYSeries upload;
	private XYSeries download;
	public ChartPanel chartPanel;
	
	public Grafico() {

		this.upload = new XYSeries("Upload");
		this.download = new XYSeries("Download");
		
		XYSeriesCollection dataset = new XYSeriesCollection();
		dataset.addSeries(this.upload);
		dataset.addSeries(this.download);
		
		JFreeChart chart = ChartFactory.createXYLineChart(
				"Transfer Graph", // Title
				"Time", // x-axis Label
				"Speed", // y-axis Label
				dataset, // Dataset
				PlotOrientation.VERTICAL, // Plot Orientation
				true, // Show Legend
				true, // Use tooltips
				false // Configure chart to generate URLs?
		);
		this.upload.setMaximumItemCount(25);
		this.download.setMaximumItemCount(25);
		
        //XYItemRenderer rend = chart.getXYPlot().getRenderer();
        //StandardXYItemRenderer rr = (StandardXYItemRenderer)rend;
        //rr.setPlotShapes(true);
        
        this.chartPanel = new ChartPanel(chart);
        this.chartPanel.setPreferredSize(new java.awt.Dimension(140, 100));
        //setContentPane(chartPanel);

	}
	
	public void atualizeUpload(int x, int y) {
		this.upload.add(x, y);
	}
	
	public void atualizeDownload(int x, int y) {
		this.download.add(x, y);
	}

}