package gui;

import java.awt.TrayIcon;
import java.util.Random;

import javax.swing.table.DefaultTableModel;

public class ThreadBar implements Runnable {

	//TODO
	private int value;// Quantos bytes foram transportados
	private int total;// Total de bytes do arquivo
	private int speed;// Velocidade de download
	private int TimeLeft;// Tempo restante
	private int row;
	private DefaultTableModel model;
	private TrayIcon icon;
	private boolean alive;
	
	public ThreadBar(int value, int total, int speed, int TimeLeft, int row, DefaultTableModel model, TrayIcon icon) {
		this.value = value;
		this.total = total;
		this.speed = speed;
		this.TimeLeft = TimeLeft;
		this.row = row;
		this.model = model;
		this.alive = true;
		this.icon = icon;
	}
	
	@Override
	public void run() {
		// TODO Auto-generated method stub
		String arquivo = (String) this.model.getValueAt(this.row, 1);
		this.icon.displayMessage("Synch", arquivo, TrayIcon.MessageType.NONE);
		//while(this.alive)
		//	updateBar();
		example();
	}

	private void updateBar() {
		
		int aux;
		//Orgizando valores
		this.value = (this.value * 100) / this.total;
		this.speed = this.speed / 1024;// De bytes para Kbytes
		this.TimeLeft = this.TimeLeft / 1000;// De milisegundos para segundos
		
		if(this.alive) {
			this.model.setValueAt(this.value, this.row, 4);// Coluna da progress bar
			
			/*.....................Ajustando Banda Passante...............................*/
			if(this.speed < 1024) {// Kbps
				this.model.setValueAt(this.speed + " Kbps", this.row, 5);// Coluna do speed
			} else {//Mbps
				this.model.setValueAt(this.speed + " Mbps", this.row, 5);// Coluna do speed
			}
			
			/*...........................Ajustando Tempo..................................*/
			if(this.TimeLeft < 60) {
				this.model.setValueAt(this.TimeLeft + " s", this.row, 6);// Coluna do TimeLeft
			} else if(this.TimeLeft < 3600){
				aux = this.TimeLeft % 60;
				this.model.setValueAt((this.TimeLeft/60) + " m " + aux + " s", this.row, 6);// Coluna do TimeLeft
			} else {
				aux = this.TimeLeft % 3600;
				this.model.setValueAt((this.TimeLeft/3600) + " h " + aux + " m", this.row, 6);// Coluna do TimeLeft
			}
			
				
		}
		
		try {
			Thread.sleep(1000);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
	
	private void example() {//TODO
		
		Random rand = new Random();
		
		for(int i = 0; i <= 100; i++) {
			
			if(this.alive) {
			
				this.model.setValueAt(i, this.row, 3);// Coluna da progress bar
				
				int speed = rand.nextInt(1000);
				this.model.setValueAt(speed + " Kbps", this.row, 4);// Coluna do speed
				
				int time = rand.nextInt(10);
				int aux = rand.nextInt(10);
				this.model.setValueAt(time + " m " + aux + " s", this.row, 5);// Coluna do TimeLeft
				
				
				try {
					Thread.sleep(100);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
				
			}
		}
	}
	
	public void killThread() {
		this.alive = false;
	}
	
	public void setValue(int value) {
		this.value = value;
	}
	
	public void setSpeed(int speed) {
		this.speed = speed;
	}
	
	public void setTimeLeft(int TimeLeft) {
		this.TimeLeft = TimeLeft;
	}
	
}
