package userManagement;

import java.io.Serializable;
import java.net.InetAddress;

public class User implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private String name;
	private String email;

	private String password;
	//private HashMap<String, String> files;

	private InetAddress currentIP;
	private int currentPort;

	public User(String name, String email, String password) {
		super();
		this.name = name;
		this.email = email;

		this.password = password;
		//this.files = new HashMap<String, String>();

		this.currentIP = null;
		this.currentPort = 0;
	}

	public InetAddress getCurrentIP() {
		return currentIP;
	}

	public void setCurrentIP(InetAddress currentIP) {
		this.currentIP = currentIP;
	}

	public int getCurrentPort() {
		return currentPort;
	}

	public void setCurrentPort(int currentPort) {
		this.currentPort = currentPort;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}

	/*
	public void appendFile(String code, String file) {
		System.out.println(code + "   " + file);
		this.files.put(code, file);
	}

	public void removeFile(String code) {
		this.files.remove(code);
	}

	public boolean containsFile(String code) {
		return this.files.containsKey(code);
	}

	public String getAddress(String code) {
		return this.files.get(code);
	}
	*/

	@Override
	public String toString() {
		String retorno = "Name: " + this.name + "\r\nEmail: " + this.email
				+ "\r\n";
		return retorno;

	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((email == null) ? 0 : email.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		User other = (User) obj;
		if (email == null) {
			if (other.email != null)
				return false;
		} else if (!email.equals(other.email))
			return false;
		return true;
	}

}
